com.hazelcast.jet.pipeline

## Interface StreamSource<T>

- Type Parameters:
    `T` - the stream item type

      public interface StreamSource<T>

  An infinite source of data for a Jet pipeline. To aggregate the data from an infinite source, you must specify how to `window` it into finite subsets over which Jet will perform the aggregation.
  Since:
    3.0
  See Also:
    `source factory methods`

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `String` | `name()` Returns a descriptive name of this source.
    `long` | `partitionIdleTimeout()` Returns the value set by `setPartitionIdleTimeout(long)`.
    `StreamSource<T>` | `setPartitionIdleTimeout(long timeoutMillis)` Sets a timeout after which idle partitions will be excluded from watermark coalescing.
    `boolean` | `supportsNativeTimestamps()` Returns true if this source supports native timestamps.

- - ### Method Detail

    - #### name

          @Nonnull
          String name()

      Returns a descriptive name of this source.

    - #### supportsNativeTimestamps

          boolean supportsNativeTimestamps()

      Returns true if this source supports native timestamps.

    - #### setPartitionIdleTimeout

          StreamSource<T> setPartitionIdleTimeout(long timeoutMillis)

      Sets a timeout after which idle partitions will be excluded from watermark coalescing. That is, the source will advance the watermark based on events from other partitions and will ignore the idle partition. If all partitions are idle (or if the source only has one partition), the source will emit a special idle message and the downstream processor will exclude this processor from watermark coalescing.

      The default timeout is 60 seconds. Must be a positive number or 0 to disable the feature.

      Parameters:
        `timeoutMillis` - the timeout in milliseconds or zero to disable.
      Since:
        3.1

    - #### partitionIdleTimeout

          long partitionIdleTimeout()

      Returns the value set by `setPartitionIdleTimeout(long)`.
      Since:
        3.1

Copyright © 2019. All rights reserved.